﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RolandBaer.LinkedList
{
    public class LinkedListEnumerator<T> : IEnumerator<T>
    {
        private LinkedListElement<T> current;
        private LinkedList<T> list;

        public T Current
        {
            get 
            {
                if (current == null) { throw new InvalidOperationException(); }
                return current.Element; 
            }
        }

        object System.Collections.IEnumerator.Current
        {
            get
            {
                return Current;
            }
        }

        internal LinkedListEnumerator(LinkedList<T> list)
        {
            this.list = list;
        }

        public void Dispose()
        {
        }

        public bool MoveNext()
        {
            if(list.Count == 0) return false;

            if (current == null)
            {
                current = list.GetAt(0);
                return true;
            }

            current = current.Next;
            return current != null;
        }

        public void Reset()
        {
            current = null;
        }
    }
}
