using System;
using RolandBaer.LinkedList;
using TSharp.Criteria;

namespace RolandBaer.LinkedListTests
{
    testclass for LinkedListEnumerator< int >
    {
        LinkedList< int > list;
    
        testcontext
        {
            test 
            {
                list = new LinkedList < int >();
                list.Add(5);
                list.Add(8);
                list.Add(2);
                list.Add(4);
                runtest;
            }
        }
        
        test MoveNext()
        {
            System.Collections.Generic.IEnumerator< int > enumerator = new LinkedList< int >().GetEnumerator();
            runtest bool res = enumerator.MoveNext() ;
       
            assert res == false;      
        }
        
        test MoveNext()
        {
            bool res1, res2;
            LinkedList< int > list = new LinkedList< int >();
            list.Add(5);
            System.Collections.Generic.IEnumerator< int > enumerator = list.GetEnumerator();
            runtest
            {
                res1 = enumerator.MoveNext() ;
                res2 = enumerator.MoveNext() ;
            }
       
            assert res1 == true;      
            assert res2 == false;      
        }
        
        test MoveNext()
        {
            int count = 0;
            System.Collections.Generic.IEnumerator< int > enumerator = list.GetEnumerator();
            runtest
            {
                while(enumerator.MoveNext())
                    count++;
            }
       
            assert count == 4;      
        }
        
        test Current get
        {
            int res1;
            int res2;
            System.Collections.Generic.IEnumerator< int > enumerator = list.GetEnumerator();
            runtest
            {
                enumerator.MoveNext();
                res1 = enumerator.Current;
                enumerator.MoveNext();
                enumerator.MoveNext();
                res2 = enumerator.Current;
            }
       
            assert res1 == 5;      
            assert res2 == 2;      
        }

        test Current get
        {
            int res1;
            int res2;
            System.Collections.IEnumerator enumerator = list.GetEnumerator();
            runtest
            {
                enumerator.MoveNext();
                res1 = (int)enumerator.Current;
                enumerator.MoveNext();
                enumerator.MoveNext();
                res2 = (int)enumerator.Current;
            }
     
            assert res1 == 5;      
            assert res2 == 2;      
        }
        
        test Current get
        {
            LinkedList< int > list = new LinkedList< int >();
            System.Collections.Generic.IEnumerator< int > enumerator = list.GetEnumerator();
            runtest int res = enumerator.Current;
    
            assert thrown InvalidOperationException;      
        }
        
        test Reset()
        {
            int res1;
            int res2;
            System.Collections.IEnumerator enumerator = list.GetEnumerator();
            runtest
            {
                enumerator.MoveNext();
                res1 = (int)enumerator.Current;
                enumerator.Reset();
                enumerator.MoveNext();
                res2 = (int)enumerator.Current;
            }
     
            assert res1 == 5;      
            assert res2 == 5;      
        }    
    }
}
